## ros-one-qb-device-driver 3.1.2-1jammy.20251023.0035

=== debian/changelog ===
ros-one-qb-device-driver (3.1.2-1jammy.20251023.0035) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- qb Support Team <support@qbrobotics.com>  Thu, 23 Oct 2025 00:35:05 +0000

ros-one-qb-device-driver (3.1.2-0jammy) jammy; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 07 Jun 2024 00:00:00 -0000

ros-one-qb-device-driver (3.1.1-0jammy) jammy; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 07 Jun 2024 00:00:00 -0000

ros-one-qb-device-driver (3.1.0-0jammy) jammy; urgency=high

  * Updated Submodule
  * FIX: submodules updated and current/deflection control mode check
  * FIX: Conflict with ros-serial
  * Tested code with modification and new API

 -- qb Support Team <support@qbrobotics.com>  Wed, 26 Jul 2023 00:00:00 -0000

ros-one-qb-device-driver (3.0.6-0jammy) jammy; urgency=high

  * FEAT: added option to specify the serial port to connect to. This can be useful when is desired to use the device with virtual ports (e.g. UR)
  * FEAT: Added compatibility with new FW version of SHR
  * MINOR FIX: Changed the name of the package maintainer

 -- qb Support Team <support@qbrobotics.com>  Wed, 26 Apr 2023 00:00:00 -0000

ros-one-qb-device-driver (3.0.5-0jammy) jammy; urgency=high

  * MINOR FIX: Changed cmake version required in all packages (current version 3.0.2).

 -- qb Support Team <support@qbrobotics.com>  Wed, 07 Sep 2022 00:00:00 -0000

ros-one-qb-device-driver (3.0.4-0jammy) jammy; urgency=high

  * package compiled with qbdevice-api v1.1.3

 -- qb Support Team <support@qbrobotics.com>  Mon, 18 Jul 2022 00:00:00 -0000

ros-one-qb-device-driver (3.0.3-0jammy) jammy; urgency=high

  * package compiled with qbdevice-api v1.1.2

 -- qb Support Team <support@qbrobotics.com>  Fri, 15 Jul 2022 00:00:00 -0000

ros-one-qb-device-driver (3.0.2-0jammy) jammy; urgency=high

  * Updated qbdevice api pkg to version 1.0.2.

 -- qb Support Team <support@qbrobotics.com>  Thu, 07 Jul 2022 00:00:00 -0000

ros-one-qb-device-driver (3.0.1-0jammy) jammy; urgency=high

  * Updated qbdevice api pkg to version 1.0.1.

 -- qb Support Team <support@qbrobotics.com>  Wed, 06 Jul 2022 00:00:00 -0000

ros-one-qb-device-driver (3.0.0-0jammy) jammy; urgency=high

  * Changed internal qbdevice API with public one.
  * Created service for Homing SHR2
  * Created SHR2 class in qbrobotics-api
  * Minor changes (comments...)
  * Modified serial sub-modules: Changes done in communication_handler node
  * Modified waiting time. Works for a brief period but stop after reboot.
  * modified scanPortsAndDevicesFunction. New API implementation does not with kinematic chain.
  * Added mutex to avoid conflicts on the same serial port. Removed old and unusefull comments.
  * changes in qbrobotics-api.
  * New API migration. qb_device_driver class is no longer required.
  * API 7.X.X integration. Incompatibility with the wrapper script

 -- qb Support Team <support@qbrobotics.com>  Tue, 05 Jul 2022 00:00:00 -0000

ros-one-qb-device-driver (2.3.4-0jammy) jammy; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 08 Apr 2022 00:00:00 -0000

ros-one-qb-device-driver (2.3.3-0jammy) jammy; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 08 Apr 2022 00:00:00 -0000

ros-one-qb-device-driver (2.3.2-0jammy) jammy; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 08 Apr 2022 00:00:00 -0000

ros-one-qb-device-driver (2.3.1-0jammy) jammy; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 08 Apr 2022 00:00:00 -0000

ros-one-qb-device-driver (2.3.0-0jammy) jammy; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 08 Apr 2022 00:00:00 -0000

ros-one-qb-device-driver (2.2.1-0jammy) jammy; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 27 Aug 2021 00:00:00 -0000

ros-one-qb-device-driver (2.2.0-0jammy) jammy; urgency=high

  * Replaced error stream with throttle
  * Fixed crash when unplagged device is plugged at runtime.
  * Created message published in a topic by communication_handler that contains the connection status of each device.
  * Implemented rescanning when device is not found
  * Deactivation bug fixed
  * Fixed reconnection on killing nodes.
  * Add methods to retrieve actual device references
  * Refactor Gazebo plugin to prepare for SoftHand simulation
  * Added the control mode switch service. Added a parameter to choose to use .yaml limits or firmware ones.
  * Fix init when no device is found on the given port
  * Update license
  * Update arg description
  * Added a parameter to use the device with or without other robots. Added some motor limits when the qbmoves are used in kinematic configs.

 -- qb Support Team <support@qbrobotics.com>  Fri, 27 Aug 2021 00:00:00 -0000

ros-one-qb-device-driver (2.1.1-0jammy) jammy; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Mon, 07 Oct 2019 00:00:00 -0000

ros-one-qb-device-driver (2.1.0-0jammy) jammy; urgency=high

  * Improve inheritance for other devices
  * Update documentation
  * Fix minor style issues

 -- qb Support Team <support@qbrobotics.com>  Tue, 28 May 2019 00:00:00 -0000

ros-one-qb-device-driver (2.0.3-0jammy) jammy; urgency=high

  * Update license agreement copyright

 -- qb Support Team <support@qbrobotics.com>  Thu, 09 Aug 2018 00:00:00 -0000

ros-one-qb-device-driver (2.0.2-0jammy) jammy; urgency=high

  * Exclude dummy boards from the connected device list

 -- qb Support Team <support@qbrobotics.com>  Tue, 07 Aug 2018 00:00:00 -0000

ros-one-qb-device-driver (2.0.1-0jammy) jammy; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 01 Jun 2018 00:00:00 -0000

ros-one-qb-device-driver (2.0.0-0jammy) jammy; urgency=high

  * Move sleep at low level (next to API)
  * Add method to temporarily change PID parameters
  * Fix doxygen documentation
  * Fix communication errors with asynchronous reads
  * Refactor node registration


## ros-one-qb-device-driver 3.1.2-1jammy.20260220.2133

=== api/qbdevice-api-7.x.x/qbrobotics-driver/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.1 FATAL_ERROR)
project(qbrobotics_driver VERSION 7.2.5 LANGUAGES CXX)
get_filename_component(API_PATH ../ ABSOLUTE)
if(EXISTS "${API_PATH}/serial/CMakeLists.txt")
        message("-- [ ${PROJECT_NAME}] Serial folder found")
endif()
SET(CMAKE_PREFIX_PATH ${API_PATH}/serial)
message("-- [ ${PROJECT_NAME}] start compiling")
find_package(Serial REQUIRED)
add_library(qbrobotics_driver 
  STATIC # [SHARED | STATIC]
  libs/research/src/qbrobotics_research_api.cpp
  libs/research/src/qbrobotics_research_api_wrapper.cpp
  libs/research/src/qbsofthand_research_api.cpp
  libs/research/src/qbmove_research_api.cpp
  libs/research/src/qbsofthand2_research_api.cpp
  libs/research/src/qbsoftclaw_api.cpp
)
target_include_directories(qbrobotics_driver PUBLIC
  $<BUILD_INTERFACE:${qbrobotics_driver_BINARY_DIR}/include>
  $<BUILD_INTERFACE:${qbrobotics_driver_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>
  "$<BUILD_INTERFACE:${Serial_SOURCE_DIR}/include>"
)
target_include_directories(qbrobotics_driver 
  PUBLIC  #TODO: make PRIVATE?
    "$<BUILD_INTERFACE:${qbrobotics_driver_BINARY_DIR}/libs/research/include>"
    "$<BUILD_INTERFACE:${qbrobotics_driver_SOURCE_DIR}/libs/research/include>"
  PRIVATE
    "$<BUILD_INTERFACE:${qbrobotics_driver_SOURCE_DIR}/libs/research/src>"
)
target_link_libraries(qbrobotics_driver PRIVATE
  Serial::Serial
)
set_target_properties(qbrobotics_driver PROPERTIES
  CXX_STANDARD 14
  CXX_STANDARD_REQUIRED ON
  CXX_EXTENSIONS NO
)
add_library(qbrobotics_driver::qbrobotics_driver ALIAS qbrobotics_driver)

install(DIRECTORY libs/research/include
  DESTINATION include
)
install(TARGETS qbrobotics_driver EXPORT qbrobotics_driverTargets
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
  RUNTIME DESTINATION bin
)
install(EXPORT qbrobotics_driverTargets
  FILE qbrobotics_driverTargets.cmake
  NAMESPACE qbrobotics_driver::
  DESTINATION lib/cmake/qbrobotics_driver
)

include(CMakePackageConfigHelpers)
configure_package_config_file(qbrobotics_driverConfig.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/qbrobotics_driverConfig.cmake
  INSTALL_DESTINATION lib/cmake/qbrobotics_driver
)
write_basic_package_version_file(qbrobotics_driverConfigVersion.cmake
  VERSION ${qbrobotics_driver_VERSION}
  COMPATIBILITY SameMajorVersion
)
install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/qbrobotics_driverConfig.cmake ${CMAKE_CURRENT_BINARY_DIR}/qbrobotics_driverConfigVersion.cmake
  DESTINATION lib/cmake/qbrobotics_driver
)

# Tests
set(TESTS false) # choose if enabling tests or not
if(TESTS)
  enable_testing()
  find_package(GTest REQUIRED CONFIG)

  add_executable(qbrobotics_research_api_communication
    tests/qbrobotics_research_api_communication.cpp
  )
  target_link_libraries(qbrobotics_research_api_communication PRIVATE
    qbrobotics_driver::qbrobotics_driver
    Serial::Serial
    GTest::gtest
    GTest::gmock
    GTest::gtest_main
  )
  set_target_properties(qbrobotics_research_api_communication PROPERTIES
    CXX_STANDARD 14
    CXX_STANDARD_REQUIRED ON
    CXX_EXTENSIONS NO
  )
  add_test(NAME qbrobotics_research_api_communication_tests
    COMMAND qbrobotics_research_api_communication
  )

  add_executable(qbrobotics_research_api_wrapper_communication
    tests/qbrobotics_research_api_wrapper_communication.cpp
  )
  target_link_libraries(qbrobotics_research_api_wrapper_communication PRIVATE
    qbrobotics_driver::qbrobotics_driver
    Serial::Serial
    GTest::gtest
    GTest::gmock
    GTest::gtest_main
  )
  set_target_properties(qbrobotics_research_api_wrapper_communication PROPERTIES
    CXX_STANDARD 14
    CXX_STANDARD_REQUIRED ON
    CXX_EXTENSIONS NO
  )
  add_test(NAME qbrobotics_research_api_wrapper_communication_tests
    COMMAND qbrobotics_research_api_wrapper_communication
  )
endif()

=== api/qbdevice-api-7.x.x/serial/CMakeLists.txt ===
###
#  MIT License
#
#  Copyright (c) 2020 Alessandro Tondo
#  Copyright (c) 2012 William Woodall, John Harrison
#
#  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated
#  documentation files (the "Software"), to deal in the Software without restriction, including without limitation
#  the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and
#  to permit persons to whom the Software is furnished to do so, subject to the following conditions:
#
#  The above copyright notice and this permission notice shall be included in all copies or substantial portions of
#  the Software.
#
#  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO
#  THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
#  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
#  SOFTWARE.
#

cmake_minimum_required(VERSION 3.5.1 FATAL_ERROR)
project(Serial VERSION 2.0.5 LANGUAGES CXX)
message("-- [ ${PROJECT_NAME}] start compiling")
if(APPLE)
  find_library(COREFOUNDATION_LIBRARY CoreFoundation)
  if (NOT COREFOUNDATION_LIBRARY)
    message(FATAL_ERROR "CoreFoundation framework not found.")
  endif()
  find_library(IOKIT_LIBRARY IOKit)
  if (NOT IOKIT_LIBRARY)
    message(FATAL_ERROR "IOKit framework not found.")
  endif()
elseif(UNIX)
  include(GNUInstallDirs)
elseif(WIN32)
  if (MSVC_VERSION GREATER_EQUAL "1900")
    include(CheckCXXCompilerFlag)
    CHECK_CXX_COMPILER_FLAG("/std:c++latest" _cpp_latest_flag_supported)
    if (_cpp_latest_flag_supported)
      add_compile_options("/std:c++latest")
    endif()
  endif()
  add_definitions(-DUNICODE -D_UNICODE)
else()
  message(FATAL_ERROR "Not supported platform.")
endif()

add_library(Serial 
  STATIC  # [SHARED | STATIC]
  src/serial.cpp
)
target_include_directories(Serial 
  PUBLIC
    "$<BUILD_INTERFACE:${Serial_SOURCE_DIR}/include>"
  PRIVATE
    "$<BUILD_INTERFACE:${Serial_SOURCE_DIR}/src>"
)
include_directories(Serial SHARED
  include
)
if(APPLE)
  target_sources(Serial PRIVATE
    src/impl/impl_unix.cpp
    src/impl/list_ports/list_ports_macos.cpp
  )
  target_link_libraries(Serial PRIVATE
    "-framework CoreFoundation"
    "-framework IOKit"
  )
elseif(UNIX)
  target_sources(Serial PRIVATE
    src/impl/impl_unix.cpp
    src/impl/list_ports/list_ports_linux.cpp
  )
else()  # already asserted WIN32 during find_package block
  target_sources(Serial PRIVATE
    src/impl/impl_win.cpp
    src/impl/list_ports/list_ports_win.cpp
  )
  target_link_libraries(Serial PRIVATE
    setupapi
  )
endif()
# target_compile_features(Serial PUBLIC cxx_std_11) is available only from CMake 3.8
if(NOT WIN32)
  set_target_properties(Serial PROPERTIES
    CXX_STANDARD 14
    CXX_STANDARD_REQUIRED ON
    CXX_EXTENSIONS NO
  )
endif()
install(TARGETS
        Serial
    EXPORT SerialConfig
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)
export(TARGETS
        Serial
    NAMESPACE Serial::
    FILE "${CMAKE_CURRENT_SOURCE_DIR}/SerialConfig.cmake"
)
install(EXPORT
        SerialConfig
    DESTINATION "${CMAKE_CURRENT_SOURCE_DIR}/"
    NAMESPACE Serial::
)

# Tests
set(TESTS false) # choose if enabling tests or not
if(TESTS)
  enable_testing()
  find_package(GTest REQUIRED CONFIG)

  add_executable(unix_serial_tests
    tests/unix_serial_tests.cpp
  )
  target_link_libraries(unix_serial_tests PRIVATE
    Serial::Serial
    GTest::gtest
    GTest::gmock
    GTest::gtest_main
  )
  if(UNIX)
  target_link_libraries(unix_serial_tests PRIVATE
    util  #FIXME: this is just to use the already existing tests
  )
  endif()
  set_target_properties(unix_serial_tests PROPERTIES
    CXX_STANDARD 11
    CXX_STANDARD_REQUIRED ON
    CXX_EXTENSIONS NO
  )
  add_test(NAME unix_serial_tests
    COMMAND unix_serial_tests
  )

  add_executable(unix_timer_tests
    tests/unix_timer_tests.cpp
  )
  target_link_libraries(unix_timer_tests PRIVATE
    Serial::Serial
    GTest::gtest
    GTest::gtest_main
  )
  set_target_properties(unix_timer_tests PROPERTIES
    CXX_STANDARD 11
    CXX_STANDARD_REQUIRED ON
    CXX_EXTENSIONS NO
  )
  add_test(NAME unix_timer_tests
    COMMAND unix_timer_tests
  )

  add_executable(list_ports_tests
    tests/list_ports_tests.cpp
  )
  target_link_libraries(list_ports_tests PRIVATE
    Serial::Serial
    GTest::gtest
    GTest::gmock
    GTest::gtest_main
  )
  set_target_properties(list_ports_tests PROPERTIES
    CXX_STANDARD 11
    CXX_STANDARD_REQUIRED ON
    CXX_EXTENSIONS NO
  )
  add_test(NAME list_ports_tests
    COMMAND list_ports_tests
  )
endif()

=== debian/changelog ===
ros-one-qb-device-driver (3.1.2-1jammy.20260220.2133) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- qb Support Team <support@qbrobotics.com>  Fri, 20 Feb 2026 21:33:28 +0000

=== debian/control ===
Source: ros-one-qb-device-driver
Section: misc
Priority: optional
Maintainer: qb Support Team <support@qbrobotics.com>
Build-Depends: debhelper (>= 9.0.0), ros-one-catkin, ros-one-qb-device-srvs, ros-one-qb-device-utils, ros-one-roscpp
Homepage: http://wiki.ros.org/qb_device_driver
Standards-Version: 3.9.2

Package: ros-one-qb-device-driver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-one-qb-device-srvs, ros-one-qb-device-utils, ros-one-roscpp
Description: This package contains a device-independent API wrapper for qbrobotics® devices.

## ros-one-qb-device-driver 3.1.2-1noble.20251023.0033

=== debian/changelog ===
ros-one-qb-device-driver (3.1.2-1noble.20251023.0033) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- qb Support Team <support@qbrobotics.com>  Thu, 23 Oct 2025 00:33:39 +0000

ros-one-qb-device-driver (3.1.2-0noble) noble; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 07 Jun 2024 00:00:00 -0000

ros-one-qb-device-driver (3.1.1-0noble) noble; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 07 Jun 2024 00:00:00 -0000

ros-one-qb-device-driver (3.1.0-0noble) noble; urgency=high

  * Updated Submodule
  * FIX: submodules updated and current/deflection control mode check
  * FIX: Conflict with ros-serial
  * Tested code with modification and new API

 -- qb Support Team <support@qbrobotics.com>  Wed, 26 Jul 2023 00:00:00 -0000

ros-one-qb-device-driver (3.0.6-0noble) noble; urgency=high

  * FEAT: added option to specify the serial port to connect to. This can be useful when is desired to use the device with virtual ports (e.g. UR)
  * FEAT: Added compatibility with new FW version of SHR
  * MINOR FIX: Changed the name of the package maintainer

 -- qb Support Team <support@qbrobotics.com>  Wed, 26 Apr 2023 00:00:00 -0000

ros-one-qb-device-driver (3.0.5-0noble) noble; urgency=high

  * MINOR FIX: Changed cmake version required in all packages (current version 3.0.2).

 -- qb Support Team <support@qbrobotics.com>  Wed, 07 Sep 2022 00:00:00 -0000

ros-one-qb-device-driver (3.0.4-0noble) noble; urgency=high

  * package compiled with qbdevice-api v1.1.3

 -- qb Support Team <support@qbrobotics.com>  Mon, 18 Jul 2022 00:00:00 -0000

ros-one-qb-device-driver (3.0.3-0noble) noble; urgency=high

  * package compiled with qbdevice-api v1.1.2

 -- qb Support Team <support@qbrobotics.com>  Fri, 15 Jul 2022 00:00:00 -0000

ros-one-qb-device-driver (3.0.2-0noble) noble; urgency=high

  * Updated qbdevice api pkg to version 1.0.2.

 -- qb Support Team <support@qbrobotics.com>  Thu, 07 Jul 2022 00:00:00 -0000

ros-one-qb-device-driver (3.0.1-0noble) noble; urgency=high

  * Updated qbdevice api pkg to version 1.0.1.

 -- qb Support Team <support@qbrobotics.com>  Wed, 06 Jul 2022 00:00:00 -0000

ros-one-qb-device-driver (3.0.0-0noble) noble; urgency=high

  * Changed internal qbdevice API with public one.
  * Created service for Homing SHR2
  * Created SHR2 class in qbrobotics-api
  * Minor changes (comments...)
  * Modified serial sub-modules: Changes done in communication_handler node
  * Modified waiting time. Works for a brief period but stop after reboot.
  * modified scanPortsAndDevicesFunction. New API implementation does not with kinematic chain.
  * Added mutex to avoid conflicts on the same serial port. Removed old and unusefull comments.
  * changes in qbrobotics-api.
  * New API migration. qb_device_driver class is no longer required.
  * API 7.X.X integration. Incompatibility with the wrapper script

 -- qb Support Team <support@qbrobotics.com>  Tue, 05 Jul 2022 00:00:00 -0000

ros-one-qb-device-driver (2.3.4-0noble) noble; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 08 Apr 2022 00:00:00 -0000

ros-one-qb-device-driver (2.3.3-0noble) noble; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 08 Apr 2022 00:00:00 -0000

ros-one-qb-device-driver (2.3.2-0noble) noble; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 08 Apr 2022 00:00:00 -0000

ros-one-qb-device-driver (2.3.1-0noble) noble; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 08 Apr 2022 00:00:00 -0000

ros-one-qb-device-driver (2.3.0-0noble) noble; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 08 Apr 2022 00:00:00 -0000

ros-one-qb-device-driver (2.2.1-0noble) noble; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 27 Aug 2021 00:00:00 -0000

ros-one-qb-device-driver (2.2.0-0noble) noble; urgency=high

  * Replaced error stream with throttle
  * Fixed crash when unplagged device is plugged at runtime.
  * Created message published in a topic by communication_handler that contains the connection status of each device.
  * Implemented rescanning when device is not found
  * Deactivation bug fixed
  * Fixed reconnection on killing nodes.
  * Add methods to retrieve actual device references
  * Refactor Gazebo plugin to prepare for SoftHand simulation
  * Added the control mode switch service. Added a parameter to choose to use .yaml limits or firmware ones.
  * Fix init when no device is found on the given port
  * Update license
  * Update arg description
  * Added a parameter to use the device with or without other robots. Added some motor limits when the qbmoves are used in kinematic configs.

 -- qb Support Team <support@qbrobotics.com>  Fri, 27 Aug 2021 00:00:00 -0000

ros-one-qb-device-driver (2.1.1-0noble) noble; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Mon, 07 Oct 2019 00:00:00 -0000

ros-one-qb-device-driver (2.1.0-0noble) noble; urgency=high

  * Improve inheritance for other devices
  * Update documentation
  * Fix minor style issues

 -- qb Support Team <support@qbrobotics.com>  Tue, 28 May 2019 00:00:00 -0000

ros-one-qb-device-driver (2.0.3-0noble) noble; urgency=high

  * Update license agreement copyright

 -- qb Support Team <support@qbrobotics.com>  Thu, 09 Aug 2018 00:00:00 -0000

ros-one-qb-device-driver (2.0.2-0noble) noble; urgency=high

  * Exclude dummy boards from the connected device list

 -- qb Support Team <support@qbrobotics.com>  Tue, 07 Aug 2018 00:00:00 -0000

ros-one-qb-device-driver (2.0.1-0noble) noble; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 01 Jun 2018 00:00:00 -0000

ros-one-qb-device-driver (2.0.0-0noble) noble; urgency=high

  * Move sleep at low level (next to API)
  * Add method to temporarily change PID parameters
  * Fix doxygen documentation
  * Fix communication errors with asynchronous reads
  * Refactor node registration


## ros-one-qb-device-driver 3.1.2-1noble.20260220.2139

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2 FATAL_ERROR)
project(qb_device_driver VERSION 3.1.2 LANGUAGES CXX)

# Dependency Settings
find_package(catkin REQUIRED
  COMPONENTS
    roscpp
    qb_device_srvs
    qb_device_utils
)
add_subdirectory(api/qbdevice-api-7.x.x)

include_directories(include
  ${catkin_INCLUDE_DIRS}
)

catkin_package(
  INCLUDE_DIRS
    include
  CATKIN_DEPENDS
    roscpp
    qb_device_srvs
    qb_device_utils
)

# Build Settings
add_executable(qb_device_communication_handler
  src/main.cpp
  src/qb_device_communication_handler.cpp
)

target_include_directories(qb_device_communication_handler
  PRIVATE
    ${Serial_SOURCE_DIR}/include/serial
)

target_link_libraries(qb_device_communication_handler
  PRIVATE
    Serial
    qbrobotics_driver
  PUBLIC
    ${catkin_LIBRARIES}
)

add_dependencies(qb_device_communication_handler
  ${${PROJECT_NAME}_EXPORTED_TARGETS}
  ${catkin_EXPORTED_TARGETS}
)

# Installation
install(
  TARGETS qb_device_communication_handler
  RUNTIME DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/
)

install(
  DIRECTORY
    include/${PROJECT_NAME}/
  DESTINATION
    ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)

install(
  DIRECTORY
    launch/
  DESTINATION
    ${CATKIN_PACKAGE_SHARE_DESTINATION}/launch
)

=== api/qbdevice-api-7.x.x/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.1)
project(qbrobotics_device_API VERSION 1.1.7 LANGUAGES CXX)
message("-- [ ${PROJECT_NAME}] start compiling")

# Add dependencies in the order you want them to build.
add_subdirectory(serial)
add_subdirectory(qbrobotics-driver)

=== debian/changelog ===
ros-one-qb-device-driver (3.1.2-1noble.20260220.2139) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- qb Support Team <support@qbrobotics.com>  Fri, 20 Feb 2026 21:39:40 +0000

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/one/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_configure -- \
		-DFETCHCONTENT_FULLY_DISCONNECTED=OFF \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/one" \
		-DCMAKE_PREFIX_PATH="/opt/ros/one" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-one-qb-device-driver//opt/ros/one/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_install
